100 REMark MiniView simple text file viewer
110 REMark by Dilwyn Jones 27.2.00
120 REMark $$asmb=win1_bootup_qlib_ext,0,12
130 :
140 IF Q_MYJOB <> 0 THEN
150   OPEN #0,'con_512x256a0x0'
160   f$ = CMD$
170 ELSE
180   f$ = '' : REMark filename of text file to load
190 END IF
200 WINDOW #0,512,256,0,0
210 BORDER #0,1,255
220 PAPER #0,0 : INK #0,7
230 lines% = 0 : y% = 0 : y1% = 0
240 IF f$ = '' THEN LOAD_FILE : ELSE READ_FILE
250 IF lines% = 0 THEN
260   CLS #0 : INK #0,7
270   PRINT#0,'No text to display!'
280   PRINT #0,'Press any key to end program.'
290   Q_CURSON #0 : PAUSE : Q_CURSOFF #0
300   STOP
310 END IF
320 :
330 REPeat program
340   INK #0,7 : AT #0,24,79
350   Q_CURSON #0 : key = CODE(INKEY$(-1)) : Q_CURSOFF #0
360   SELect ON key
370     =27 : EXIT program
380     =CODE('L'),CODE('l') : LOAD_FILE
390     =208 : REMark up one line
400       y2% = y% : y3% = y1%
410       y% = y% - 1 : IF y% < 0 THEN y% = 0
420       y1% = y%+23
430       IF y1% >= lines% THEN y1% = lines%-1
440       IF y1%-y% > 23 THEN
450         y% = y1%-23
460         IF y% < 0 THEN
470           y% = 0 : y1% = y% + 23
480         END IF
490       END IF
500       IF y% <> y2% OR y1% <> y3% THEN
510         IF y% = (y2%-1) AND y1% = (y3%-1) THEN
520           REMark fast scroll up
530           AT #0,24,0 : SCROLL #0,10,1
540           AT #0,0,0 : PRINT #0,txt$(y%);
550         ELSE
560           REDRAW_DISPLAY
570         END IF
580       END IF
590     =216 : REMark scroll down
600       y2% = y% : y3% = y1%
610       y1% = y1% + 1
620       IF y1% >= lines% THEN y1% = (lines%-1)
630       y% = y1% - 23
640       IF y% < 0 THEN
650         y% = 0 : y1% = y1% + 23
660         IF y1% >= lines% THEN y1% = lines%-1
670       END IF
680       IF y% <> y2% OR y1% <> y3% THEN
690         REMark need to redraw
700         IF y% = (y2%+1) AND y1% = (y3%+1) THEN
710           REMark fast scroll down
720           AT #0,24,0 : SCROLL #0,-10,1
730           AT #0,y1%-y%,0 : PRINT #0,txt$(y1%);
740         ELSE
750           REDRAW_DISPLAY
760         END IF
770       END IF
780     =212 : REMark page up
790       y2% = y% : y3% = y1%
800       y% = y%-23 : IF y% < 0 THEN y% = 0
810       y1% = y% + 23
820       IF y1% >= lines% THEN y1% = lines%-1
830       IF y% <> y2% OR y1% <> y3% THEN REDRAW_DISPLAY
840     =220 : REMark Page down
850       y2% = y% : y3% = y1%
860       y1% = y1% + 23 : IF y1% >= lines% THEN y1% = lines%-1
870       y% = y1% - 23 : IF y% < 0 THEN y% = 0
880       IF y% <> y2% OR y1% <> y3% THEN REDRAW_DISPLAY
890     =213 : REMark goto top
900       y% = 0 : y1% = 23
910       IF y1% >= lines% THEN y1% = lines%-1
920       REDRAW_DISPLAY
930     =221 : REMark goto bottom
940       y1% = lines%-1
950       y% = y1%-23 : IF y% < 0 THEN y% = 0
960       REDRAW_DISPLAY
970     =244,250 : REMark refresh display
980       WINDOW #0,512,256,0,0 : BORDER #0,1,255
990       PAPER #0,0 : INK #0,7 : CLS #0 : REDRAW_DISPLAY
1000     =CODE('P'),CODE('p') : REMark print text
1010       PRINT_TEXT
1020   END SELect
1030 END REPeat program
1040 STOP
1050 :
1060 DEFine PROCedure LOAD_FILE
1070   CLS #0
1080   INPUT #0,'Load which file > ';f$
1090   IF f$ = '' THEN
1100     REDRAW_DISPLAY : RETurn
1110   END IF
1120   READ_FILE
1130 END DEFine
1140 :
1150 DEFine PROCedure READ_FILE
1160   REMark tries to open a file called f$
1170   Q_ERR_ON 'OPEN_IN'
1180   OPEN_IN #3,f$ : fer = Q_ERR
1190   Q_ERR_OFF 'OPEN_IN'
1200   IF fer < 0 THEN
1210     PRINT #0,\'Unable to load ';f$
1220     PRINT #0,'Press any key to continue.'
1230     Q_CURSON #0 : PAUSE : Q_CURSOFF #0
1240     REDRAW_DISPLAY : RETurn
1250   END IF
1260   REMark read through file to count number of lines
1270   l% = 0
1280   REPeat loop
1290     IF EOF(#3):EXIT loop
1300     INPUT #3,t$ : l% = l%+1
1310   END REPeat loop
1320   CLOSE #3 : OPEN_IN #3,f$
1330   DIM txt$(l%-1,80)
1340   FOR a = 0 TO l%-1
1350     INPUT #3,txt$(a)
1360   END FOR a
1370   CLOSE #3
1380   REMark we have the text in an array
1390   REMark we have closed the file
1400   REMark display the text
1410   y% = 0 : lines% = l%
1420   REDRAW_DISPLAY
1430 END DEFine
1440 :
1450 DEFine PROCedure REDRAW_DISPLAY
1460   REMark display has 25 lines of text, 24 of which are used for the file
1470   REMark bottom line for prompts
1480   CLS #0
1490   y1% = y%+23 : REMark last line to display
1500   IF y1% >= lines% THEN y1% = lines%-1
1510   IF y1%-y% < 23 THEN y% = y1% - 23
1520   IF y% < 0 THEN y% = 0
1530   AT #0,24,0 : CLS #0,1 : INK #0,7
1540   FOR a = y% TO y1%
1550     AT #0,a-y%,0 : PRINT #0,txt$(a);
1560   END FOR a
1570   AT #0,24,0 : INK #0,4 : PRINT #0,CHR$(190)&CHR$(191)&'-Scroll   '&CHR$(190)&CHR$(191)&'-Page Up/Down   ALT SHIFT'&CHR$(190)&CHR$(191)&'-Top/End   ESC-Quit   L-Load   P-Print ';
1580 END DEFine REDRAW_DISPLAY
1590 :
1600 DEFine PROCedure PRINT_TEXT
1610   IF lines% = 0 THEN RETurn
1620   CLS #0
1630   INPUT #0,'Print to > ';p$
1640   IF p$ = '' THEN
1650     REDRAW_DISPLAY : RETurn
1660   END IF
1670   Q_ERR_ON 'open_new' : OPEN_NEW #3,p$
1680   fer = Q_ERR : Q_ERR_OFF 'open_new'
1690   IF fer < 0 THEN
1700     PRINT #0,'Printing failed.'
1710     PRINT #0,'Press any key to continue. ';
1720     Q_CURSON #0 : PAUSE : Q_CURSOFF #0
1730     REDRAW_DISPLAY : RETurn
1740   END IF
1750   Q_ERR_ON 'print' : PRINT #3,''; : fer = Q_ERR
1760   Q_ERR_OFF 'print'
1770   IF fer < 0 THEN
1780     PRINT #0,'Printing failed.'
1790     PRINT #0,'Press any key to continue. ';
1800     Q_CURSON #0 : PAUSE : Q_CURSOFF #0
1810     REDRAW_DISPLAY : RETurn
1820   END IF
1830   FOR a = 0 TO lines% -1 : PRINT #3,txt$(a)
1840   CLOSE #3
1850   REDRAW_DISPLAY
1860 END DEFine
